struct GData00 {
    vec3 SceneNormal;
    ivec2 BlockID;
    vec2 Lightmap;
};

struct GData01 {
    vec4 MaterialData;
    vec2 OcclusionData;     //AO, POM Shadows
    float SurfaceWetness;
};

#ifdef GBufferREAD0
#define GBuffer00Image colortex1
GData00 ReadGbuffer0(ivec2 uv) {
    vec4 image  = texelFetch(GBuffer00Image, uv, 0);
    return GData00(decodeNormal(image.xy), unpack2x8I(image.z), unpack2x8(image.w));
}
#endif

#ifdef GBufferPACK0
vec4 PackGbuffer0(GData00 Data) {
    return vec4(encodeNormal(Data.SceneNormal), pack2x8(Data.BlockID), pack2x8(Data.Lightmap));
}
#endif

#ifdef GBufferREAD1
#define GBuffer01Image colortex2
GData01 ReadGbuffer1(ivec2 uv) {
    vec4 image  = texelFetch(GBuffer01Image, uv, 0);
    return GData01(vec4(unpack2x8(image.x), unpack2x8(image.y)), unpack2x8(image.z), unpack2x8(image.w).x);
}
#endif

#ifdef GBufferPACK1
vec4 PackGbuffer1(GData01 Data) {
    return vec4(pack2x8(Data.MaterialData.xy), pack2x8(Data.MaterialData.zw), pack2x8(Data.OcclusionData), pack2x8(vec2(Data.SurfaceWetness, 0)));
}
#endif