#include "/lib/head.glsl"

#if (defined useInstancing && defined generateShadowmap)
const int countInstances = 2;
#else
const int countInstances = 1;
#endif

uniform int instanceId;

attribute vec3 at_midBlock;
attribute vec4 at_tangent;
attribute vec4 mc_Entity;
attribute vec4 mc_midTexCoord;

uniform mat4 shadowModelViewInverse;

out vertexOut {
    flat int InstanceID;
    flat int voxelMode;
    flat int blockID;

    flat ivec2 objectID;

    vec2 UV;
    vec2 MidUV;

    vec3 Tint;
    vec3 LocalLocation;
    vec3 SceneLocation;
    vec3 CenteredSceneLocation;
    flat vec3 Normal;

    flat vec4 Tangent;
};

#include "/lib/mat/idTable.glsl"

void main() {

    #ifdef generateShadowmap
    InstanceID      = instanceId;
    #else
    InstanceID      = 1;
    #endif

    UV              = (gl_TextureMatrix[0] * gl_MultiTexCoord0).xy;
    MidUV           = (gl_TextureMatrix[0] * mc_midTexCoord).xy;

    Tint            = gl_Color.rgb;

    vec4 position   = gl_Vertex;

    LocalLocation   = position.xyz;

        position    = gl_ModelViewMatrix * position;
        position    = shadowModelViewInverse * position;

    SceneLocation   = position.xyz;

    CenteredSceneLocation = position.xyz + (at_midBlock / 64.0) * 0.9;

    Normal          = gl_Normal;
    Tangent         = at_tangent;

    int mcEntity    = int(mc_Entity.x);

    voxelMode       = 1;
    if (mcEntity == 0
     || mcEntity == 1010
     || mcEntity == 1011
     || mcEntity == 10022
     || mcEntity == 10023
     || mcEntity == 10024
     || mcEntity == 10025
     || mcEntity == 1040
     ) voxelMode = 0;

    objectID        = ivec2(remapShapeID(mcEntity), remapEmissionID(mcEntity));

    blockID         = 0;
    if (mcEntity == 1040) blockID = 102;
}